/*
 * com/ngon/tap/Block.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import java.awt.Point;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.StringTokenizer;

/**
 * class Block
 */
final class Block {
    
    int blockNr;
    Point mv = new Point();
    
    Block() {}
    
    static Block parseRow(ResultSet rs) throws SQLException {
        Block b = new Block();
        b.blockNr = rs.getInt(1);
        b.mv.x    = rs.getInt(2);
        b.mv.y    = rs.getInt(3);
        return b;
    }
    
    static Block parseEncodedString(String s, String delim) {
        Block b = new Block();
        StringTokenizer st = new StringTokenizer(s, delim);
        if (st.countTokens() != 3) {
            return null;
        }
        b.blockNr = Integer.parseInt(st.nextToken());
        b.mv.x    = Integer.parseInt(st.nextToken());
        b.mv.y    = Integer.parseInt(st.nextToken());
        return b;
    }
    
    StringBuffer toEncodedStringBuffer(String delim) {
        return new StringBuffer().
            append(blockNr).append(delim).
            append(mv.x).append(delim).
            append(mv.y);
    }
}

