/*
 * com/ngon/tap/Clus.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import java.awt.Point;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * class Clus
 */
final class Clus {
    
    int clusterID;
    int blockSize;
    int width;
    int height;
    Point avgMV = new Point();
    Point cg = new Point();
    int avgDiv;
    int avgCurl;
    int avgRGB;
    int frameNr;
    int clipID;
    int linkWtSum;
    
    Clip clip;
    Block[] blocks;
    int weight;
    
    Clus() {}
    
    static Clus parseRow(ResultSet rs) throws SQLException {
        Clus c = new Clus();
        // See order in ClusQuery
        c.clusterID = rs.getInt(1);
        c.blockSize = rs.getInt(2);
        c.width     = rs.getInt(3);
        c.height    = rs.getInt(4);
        c.cg.x      = rs.getInt(5);
        c.cg.y      = rs.getInt(6);
        c.avgMV.x   = rs.getInt(7);
        c.avgMV.y   = rs.getInt(8);
        c.avgDiv    = rs.getInt(9);
        c.avgCurl   = rs.getInt(10);
        c.avgRGB    = rs.getInt(11);
        c.frameNr   = rs.getInt(12);
        c.clipID    = rs.getInt(13);
        c.linkWtSum = rs.getInt(14);
        return c;
    }
    
    static Clus parseEncodedString(String s, String delim) {
        Clus c = new Clus();
        StringTokenizer st = new StringTokenizer(s, delim);
        if (st.countTokens() != 14) {
            return null;
        }
        c.clusterID = Integer.parseInt(st.nextToken());
        c.blockSize = Integer.parseInt(st.nextToken());
        c.width     = Integer.parseInt(st.nextToken());
        c.height    = Integer.parseInt(st.nextToken());
        c.cg.x      = Integer.parseInt(st.nextToken());
        c.cg.y      = Integer.parseInt(st.nextToken());
        c.avgMV.x   = Integer.parseInt(st.nextToken());
        c.avgMV.y   = Integer.parseInt(st.nextToken());
        c.avgDiv    = Integer.parseInt(st.nextToken());
        c.avgCurl   = Integer.parseInt(st.nextToken());
        c.avgRGB    = Integer.parseInt(st.nextToken());
        c.frameNr   = Integer.parseInt(st.nextToken());
        c.clipID    = Integer.parseInt(st.nextToken());
        c.linkWtSum = Integer.parseInt(st.nextToken());
        return c;
    }
    
    void copyFields(Clus c) {
        this.clusterID = c.clusterID;
        this.blockSize = c.blockSize;
        this.width     = c.width;
        this.height    = c.height;
        this.cg.x      = c.cg.x;
        this.cg.y      = c.cg.y;
        this.avgMV.x   = c.avgMV.x;
        this.avgMV.y   = c.avgMV.y;
        this.avgDiv    = c.avgDiv;
        this.avgCurl   = c.avgCurl;
        this.avgRGB    = c.avgRGB;
        this.frameNr   = c.frameNr;
        this.clipID    = c.clipID;
        this.linkWtSum = c.linkWtSum;
    }
    
    StringBuffer toEncodedStringBuffer(String delim) {
        return new StringBuffer().
            append(clusterID).append(delim).
            append(blockSize).append(delim).
            append(width).append(delim).
            append(height).append(delim).
            append(cg.x).append(delim).
            append(cg.y).append(delim).
            append(avgMV.x).append(delim).
            append(avgMV.y).append(delim).
            append(avgDiv).append(delim).
            append(avgCurl).append(delim).
            append(avgRGB).append(delim).
            append(frameNr).append(delim).
            append(clipID).append(delim).
            append(linkWtSum);
    }
}

