CREATE TABLE IF NOT EXISTS clip (
    id          INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
    timestamp   TIMESTAMP,
    name        VARCHAR(255) NOT NULL,
    len         INT UNSIGNED
);
CREATE TABLE IF NOT EXISTS mvcluster (
    id          INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, 
    n_blocks    SMALLINT UNSIGNED NOT NULL, 
    width       SMALLINT UNSIGNED NOT NULL, 
    height      SMALLINT UNSIGNED NOT NULL,
    cg_x        SMALLINT NOT NULL,
    cg_y        SMALLINT NOT NULL,
    avg_mv_x    SMALLINT NOT NULL, 
    avg_mv_y    SMALLINT NOT NULL,
    avg_div     SMALLINT NOT NULL, 
    avg_curl    SMALLINT NOT NULL, 
    avg_rgb     INT UNSIGNED NOT NULL,
    frame_nr    INT UNSIGNED NOT NULL,
    clip_id     INT UNSIGNED NOT NULL,
    link_wt_sum INT UNSIGNED,
    INDEX(clip_id,frame_nr),
    INDEX(n_blocks),
    INDEX(width),
    INDEX(height),
    INDEX(cg_x),
    INDEX(cg_y),
    INDEX(avg_mv_x),
    INDEX(avg_mv_y),
    INDEX(avg_div),
    INDEX(avg_curl),
    INDEX(avg_rgb)
); 
CREATE TABLE IF NOT EXISTS mvblock (
    id              INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, 
    block_nr        SMALLINT UNSIGNED NOT NULL, 
    mv_x            SMALLINT NOT NULL, 
    mv_y            SMALLINT NOT NULL,
    mvcluster_id    INT UNSIGNED NOT NULL,
    INDEX(mvcluster_id)
); 
CREATE TABLE IF NOT EXISTS mvclusterlink (
    id              INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, 
    mvcluster_id    INT UNSIGNED NOT NULL,
    link_mvclus_id  INT UNSIGNED NOT NULL,
    link_mvclus_wt  INT UNSIGNED NOT NULL,
    INDEX(mvcluster_id)
); 

